unit DelaylaModule;

{$include RELEASE_SETTINGS.INC}
{$include DAV_Compiler.inc}
{$include VSTPLUGIN_SWITCHES.INC}

interface

uses 
  {$IFDEF FPC}
  Interfaces,
  {$ELSE}
  Windows, Types, Messages, 
  {$ENDIF}
  SysUtils, Classes, Forms, 
  DAV_Types, DAV_VSTModule, {%H-}DAV_VSTCustomModule;

  
type
  { TSimpleDelayVST }
  TSimpleDelayVST = class(TVSTModule)
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleEditOpen(Sender: TObject; var GUI: TForm; ParentWindow: THandle);
    procedure DataModuleProcess(const Inputs, Outputs: TDAVArrayOfSingleFixedArray; const SampleFrames: Cardinal);
    procedure SDDelayLengthChange(Sender: TObject; const Index: Integer; var Value: Single);
  private
    fBuffer     : array[0..1] of TDAVSingleDynArray;
    fBufferSize : Integer;
    fBufferPos  : Integer;
  end;

  
implementation

{$IFDEF FPC}
  {$R *.lfm}
{$ELSE}
  {$R *.dfm}
{$ENDIF}

uses 
  DelaylaGUI;


procedure TSimpleDelayVST.DataModuleCreate(Sender: TObject);
begin
  Parameter[0]:= 441;   // this calls SDDelayLengthChange() ..
  fBufferPos:= 0;
end;

procedure TSimpleDelayVST.DataModuleProcess(const Inputs,
  Outputs: TDAVArrayOfSingleFixedArray; const SampleFrames: Cardinal);
var
  j : Integer;
begin
  // Avoid Exception :
  if not Assigned( fBuffer[0]) then Exit;

  for j:= 0 to sampleframes -1 do
    begin
      outputs[0,j]:= inputs[0,j] +fBuffer[ 0, fBufferPos];
      outputs[1,j]:= inputs[1,j] +fBuffer[ 1, fBufferPos];
      fBuffer[ 0, fBufferPos]:= inputs[0,j];
      fBuffer[ 1, fBufferPos]:= inputs[1,j];
      Inc( fBufferPos);
      if fBufferPos >= fBufferSize
        then fBufferPos:= 0;
    end;
end;

procedure TSimpleDelayVST.DataModuleEditOpen(Sender: TObject; var GUI: TForm;
  ParentWindow: THandle);
begin
  GUI:= TVSTGUI.Create(Self);
end;

procedure TSimpleDelayVST.SDDelayLengthChange(Sender: TObject; const Index: Integer; var Value: Single);
begin
  fBufferSize:= Round( Value);
  SetLength( fBuffer[0], fBufferSize);
  SetLength( fBuffer[1], fBufferSize);
  if fBufferPos >= fBufferSize
    then fBufferPos:= 0;
end;


end.
